<?php
defined( 'OSC_SECURE' ) or die( 'Restricted access' );
/*

*/

class MyACL extends Zend_ACL
{

	private $_db;
		
	public function __construct(&$db)
	{
		
		$this->_db = 	$db;
		// I chose to write the field names into these SQL statements, so that the tables can actually contain more
		// fields than just the ones I need here without producing heavier DB load as neccessary.
		
		/// First: Create all the resources we have.
		//$resources = $db->fetchAll( $db->select()->distinct()->from( 'acl_resources', array( 'id', 'parent_id' ) ) );
		
		$sql = 'SELECT DISTINCT `id`,`parent_id` FROM `acl_resources`';
		$rs = $this->_db->Execute($sql);
		$resources= $rs->getArray(MYSQL_ASSOC);

		$resCount  = ($resources)?count( $resources ):0;
		$addCount  = 0;
		
		$allResources = array();
		if(is_array($resources))foreach($resources as $theRes ){
			$allResources[] = $theRes['id'];
			}
		if(is_array($resources))foreach($resources as $theRes ){
			if( $theRes['parent_id'] !== null && !in_array( $theRes['parent_id'], $allResources ) ){
				require_once 'Zend/Acl/Exception.php';
				throw new Zend_Acl_Exception(
					"Resource id '".$theRes['parent_id']."' does not exist"
					);
				}
			}

		while( $resCount > $addCount ){
	
			foreach( $resources as $theRes ){
				// Check if parent resource (if any) exists
				// Only add if this resource hasn't yet been added and its parent is known, if any
				if( !$this->has( $theRes['id'] ) &&
				    ( $theRes['parent_id'] === null || $this->has( $theRes['parent_id'] ) )
				  ){
					$this->add( new Zend_Acl_Resource( $theRes['id'] ), $theRes['parent_id'] );
					$addCount++;
					}
				}
			}
				
		/// Now create all roles
		/*$roles = $db->fetchAll(
			$db->select()
			->from(     array( 'r' => 'cmsusers' ),       array( 'r.username', 'i.parent_id' ) )
			->joinLeft( array( 'i' => 'acl_inheritance' ), 'r.id=i.child_id'              )
			->order(    array( 'child_id', 'order' ) )
			);*/
		
			
		$sql = 'SELECT `r`.`id`, `i`.`parent_id` FROM `cmsusers` AS r JOIN `acl_inheritance` AS i'
		. ' ON `r`.`id`=`i`.`child_id` ORDER BY `child_id`, `order`';
		
		//$sql = 'SELECT `r` . `username` as `id` , `i` . `parent_id` FROM `acl_inheritance` AS i LEFT JOIN `cmsusers` AS r ON `r` . `username` = `i` . `child_id` ORDER BY `child_id` , `order`';
		

		$rs = $this->_db->Execute($sql);
		$roles = $rs->getArray(MYSQL_ASSOC);

        if(CMS_CURRENT_USER_ID)
        {
        	$roles[] = array('id'=>CMS_CURRENT_USER_ID,'parent_id'=>2); //Members
        }	
        else 
        {

        	$roles[] = array('id'=>0,'parent_id'=>1); //Users
        }	
		

		
		$sql = 'SELECT `r`.`id` FROM `cmsusers` AS r WHERE `type`=\'acl_group\'';
		$rs = $this->_db->Execute($sql);

		while ($role = $rs->fetchRow())
		{
			$role['parent_id']=null;
			$roles[] = $role;
		}	
		
		//$roles[] = array('id'=>'Members','parent_id'=>'Users');
		//$roles[] = array('id'=>'Users','parent_id'=>null);
		$roles[] = array('id'=>2,'parent_id'=>1);
		$roles[] = array('id'=>1,'parent_id'=>null);
		
		// Create an array that stores all roles and their parents
		$dbElements = array();
		foreach( $roles as $theRole ){
			if( !isset( $dbElements[ $theRole['id'] ] ) )
				$dbElements[ $theRole['id'] ] = array();
			if( $theRole['parent_id'] !== null )
				$dbElements[ $theRole['id'] ][] = $theRole['parent_id'];
			}
		// Now add to the ACL
		$dbElemCount  = count( $dbElements );
		$aclElemCount = 0;
		
		// while there are still elements left to be added
		while( $dbElemCount > $aclElemCount ){
			// Check every element in the db
			foreach( $dbElements as $theDbElem => $theDbElemParents ){
				// Check if a parent is invalid to prevent an infinite loop
				// if the relational DBase works, this shouldn't happen
				foreach( $theDbElemParents as $theParent ){
					if( !array_key_exists( $theParent, $dbElements ) ){
						require_once 'Zend/Acl/Exception.php';
						throw new Zend_Acl_Exception(
							"Role id '$theParent' does not exist"
							);
						}
					}
				if( !$this->hasRole( $theDbElem ) &&            // if it has not yet been added to the ACL
				    ( empty( $theDbElemParents )  ||            // and no parents exist or
				      $this->hasAllRolesOf( $theDbElemParents ) // we know them all
				    )
				  ){
					// we can add to ACL
					$this->addRole( new Zend_Acl_Role( $theDbElem ), $theDbElemParents );
					$aclElemCount++;
					}
				}
			}
		
		
		/// Now create all access rules
		//$access = $db->fetchAll( $db->select()->from( 'acl_access', array( 'role_id','resource_id','privilege','allow' ) ) );
		
		$sql = 'SELECT `role_id`,`resource_id`,`privilege`,`allow` FROM `acl_access`';
		
		$rs = $this->_db->Execute($sql);
		$access = $rs->getArray(MYSQL_ASSOC);
	
		if($access)foreach( $access as $theRule )
		{
			if( $theRule['allow'] == true )
				$this->allow( $theRule['role_id'], $theRule['resource_id'], $theRule['privilege'] );
			else	$this->deny(  $theRule['role_id'], $theRule['resource_id'], $theRule['privilege'] );
			}
		}
		
		public function hasAllRolesOf( &$searchRoles ){
		foreach( $searchRoles as $theRole )
			if( !$this->hasRole( $theRole ) )
				return false;
		return true;
		}
	
}
?>
