<?php
/*

EstrateCMS

EstrateCMS is a Content Management System for professional websites.

Copyright (C) 2004, 2005, Estrate, Rudolph Froger, The Netherlands
Website:        http://www.estrate.nl
Postal address: Estrate
                Oostsingel 57B
                2612HD Delft
                The Netherlands

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

A copy of the license should be in the file named LICENSE.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

define( 'MODULE_CMSCONFIG', TRUE );

class cmsconfig
{
	
	function load_contants_file	($file)
	{

		$config = loadConfig( $file );
		if( is_array($config) ) foreach( $config as $value ) {
		if(!defined('CMS_'.strtoupper( $value[0] )))define( 'CMS_'.strtoupper( $value[0] ), trim( $value[1] ) );
		
		}
	}

	function load_contants($module='site')
	{
		
		
		
		if($module!='site')
		{
			$path=$module;
			if(strstr($module,'/'))
			{
				$last = strrpos($module,'/');
				//$path = substr($module,0,$last);
				$module = substr($module,$last+1);
			}	

			if(file_exists(CMS_CLIENT_PATH.'modules/'.$path.'/'.$module.'.conf')) cmsconfig::load_contants_file(CMS_CLIENT_PATH.'modules/'.$path.'/'.$module.'.conf');
			elseif (file_exists(CMS_CLIENT_PATH.'conf/'.$module.'.conf')) cmsconfig::load_contants_file(CMS_CLIENT_PATH.'conf/'.$module.'.conf');
			else cmsconfig::load_contants_file(CMS_LIB_PATH.$path.'/'.$module.'.conf');
		}
		else 
		{
			 cmsconfig::load_contants_file(CMS_CONFIG_PATH.$module.'.conf');
		}	
	}	
	
	
	function setGlobals( &$cfg )
	{
		//all basic globals and their default value
		$basic_globals = array(
				'debug' => 0,
				'lib_path' => '/var/estratecms/',
				'client_path' => '/var/www/httpdocs/',
				'config_path' => '/var/www/httpdocs/conf/',
				/* 
				vreemde constructie 
				ingevoerd om andere templates te kunnen gebruiken op basis van subdomain
				site.conf is dan in eerste instantie onbruikbaar, want wil keuze maken met php
				*/
			    'default_page' => 1	
		);

		foreach( $basic_globals as $key => $value ) {
			if( isset( $cfg[$key] ) ) {
				define( 'CMS_'.strtoupper( $key ), $cfg[$key] );

			} else {
				define( 'CMS_'.strtoupper( $key ), $value );
			}
		}
		
		cmsconfig::load_contants();

		//set all generic config vars which are not defined in the config file
		$globals = array(
			'templates_default_body'	=> 'cms_body',
			'templates_default_header' => 'cms_header',
			'templates_default_footer' => 'cms_footer',
			'templates_default_body_php'	=> 'cms_body_php',
			'templates_default_header_php' => 'cms_header_php',
			'templates_default_footer_php' => 'cms_footer_php',
			'css' => 'default',
			'js' => 'default',
			
			'templates_image_dir'	=> 'images/',
			'templates_positions'	=> 'main',
			
			
			'admin_name'		=> 'webmaster',
			'admin_email'		=> 'webmaster@'.str_replace('www.','',$_SERVER['SERVER_NAME']),

			'startshow'		=> 0,
			'stopshow'		=> 0,
			'status'		=> 'on',

			'admin_style_url' 	=> 'css/',
			'admin_icons_url' 	=> 'adm/icons/',
			'jscripts_url'  	=> 'jscripts/',
			'modules_jscripts_url'  	=> 'js/',
			'smileys_url'		=> 'adm/smileys/',

			'description'		=> 'EstrateCMS',
			'keywords'		=> 'OpensourceCMS,CMS,Content Management System',
			'default_page'		=> 1,
			'default_title'		=> 'EstrateCMS',
			'base_url'		=> '/',
			'domain'		=> 'http://'.$_SERVER['HTTP_HOST'],

			'languages_default' 	=> 'en',
			'languages'		=> 'en',
			
			'doctype'		=> 'xhtml1-transitional'
			//posssible values at this moment: xhtml1-transitional, xhtml1-strict
		);
		foreach( $globals as $key => $value ) {
			if( !defined( 'CMS_'.strtoupper( $key ) ) ) {
				define( 'CMS_'.strtoupper( $key ), $value );
			}
		}			
			
	}

	function load()
	{
	}

	function save()
	{
	}
	
	function adminlist( $id = 0 )
	{
	}
}
?>