<?php
/*

EstrateCMS

EstrateCMS is a Content Management System for professional websites.

Copyright (C) 2004, 2005, Estrate, Rudolph Froger, The Netherlands
Website:        http://www.estrate.nl
Postal address: Estrate
                Oostsingel 57B
                2612HD Delft
                The Netherlands

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

A copy of the license should be in the file named LICENSE.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

define( 'MODULE_CMSGUESTBOOK', TRUE );

class cmsguestbook extends EstrateDB
{
	var	$id;
	var	$title;
	var	$content;
	var	$sender;
	var	$insert_time;
	var	$update_time;
	var	$status;
	var	$securityinfo;

	function cmsguestbook( & $db )
	{
		EstrateDB::EstrateDB( $db );
		require_once( CMS_CURRENT_LANGUAGE.'.php' );
		if( !defined( 'CMS_GUESTBOOK_ADMIN_ID' ) ) {
			define( 'CMS_GUESTBOOK_ADMIN_ID', 1 );
		}
		cmsconfig::load_contants('cmsguestbook');
	}

	function check()
	{
		
		
		
		
		if( !$this->insert_time ) {
			$this->insert_time = time();
		}
		$this->update_time = time();
		if( !$this->securityinfo ) {
			$this->securityinfo = getSecurityInfo();
		}
		$this->title = strip_tags( $this->title );
		$this->content = strip_tags( $this->content );
		$this->sender = strip_tags( $this->sender );
		if( $this->title && $this->content ) {
			return TRUE;
		} else {
			return FALSE;
		}
	}

	function show( $input )
	{
		

		if( isset( $_POST['guestbooksave'] ) ) 
		{
			$message='';
			$newmsg = new cmsguestbook( $this->_db );
	 
			$newmsg->bind( $_POST );
			$newmsg->check();
			

			    if(defined('CMS_GUESTBOOK_CAPTCHA') && CMS_GUESTBOOK_CAPTCHA)
                {
                	
                if(!checkcaptcha()) 
                {
                $vars['error'] = CMSGUESTBOOK_WRONGCODE;//'Ongeldige beveiligingscode';
                }
                } 
			
			
			elseif(empty($_POST['sender']))
			{
				 $vars['error'] = CMSGUESTBOOK_SAVEFAILED; //'Geen naam ingevuld';
			}
			elseif(empty($_POST['content']))
			{
				 $vars['error'] = CMSGUESTBOOK_SAVEFAILED; //'Geen bericht ingevuld';
			}	
			if(empty($vars['error']))
			{
			
			
			//$rs = $this->_db->Execute( "SELECT id FROM ".$this->_tablename." WHERE status='on' AND title = '".$newmsg->title."' AND content = '".$newmsg->content."' AND sender = '".$newmsg->sender."'" );
			
			$rs = $this->_db->Execute( "SELECT id FROM ".$this->_tablename." WHERE status='on' AND title = '".str_replace('\'','\\\'',$newmsg->title)."' AND content = '".str_replace('\'','\\\'',$newmsg->content)."' AND sender = '".str_replace('\'','\\\'',$newmsg->sender)."'" );
			
			if( $rs && $rs->RecordCount() ) {
				//message already exists, one should not hit refresh after sending a message!
				$vars['title'] = '';
				$vars['message'] = CMSGUESTBOOK_SAVEFAILED;
				$message = cmstemplates::show( 'message', $this->_tablename, $vars );
			} else {
				if( $newmsg->save() ) {
					$vars['title'] = '';
					$vars['message'] = CMSGUESTBOOK_SAVESUCCESS;
					$message = cmstemplates::show( 'message', $this->_tablename, $vars );
					if( CMS_GUESTBOOK_ADMIN_ID ) {
						$mail_vars = get_object_vars( $newmsg );
						$mail = cmstemplates::show( 'cmsguestbook_notification.'.CMS_LANGUAGES_DEFAULT, $this->_tablename, $mail_vars );
						$mailsubject = CMSGUESTBOOK_NOTIFICATION_SUBJECT;
						$admin = new cmsusers( $this->_db );
						$admin->load( CMS_GUESTBOOK_ADMIN_ID );
						sendEmail( $admin->email, '', '', CMS_ADMIN_EMAIL, $mailsubject, $mail );
					}
				} else {
					$vars['title'] = '';
					$vars['message'] = CMSGUESTBOOK_SAVEFAILED;
					$message = cmstemplates::show( 'message', $this->_tablename, $vars );
				}
			}
			unset($vars);
			}
			else 
			{
				/* er zijn fouten */
				foreach (array('title','content','sender') as $veld)
				$vars[$veld]= empty($_POST[$veld])?'':$_POST[$veld];
			}	
		} else {
			$message = '';
		}
		if( isset( $_POST['page'] ) ) {
			$page = intval( $_POST['page'] );
		} else {
			$page = 0;
		}
		$pageitems = 10;
		$rs = $this->_db->Execute( "SELECT * FROM ".$this->_tablename." WHERE status='on'" );
		$totalitems = $rs->RecordCount();
		$totalpages = ceil( $totalitems / $pageitems );
		$rs = $this->_db->Execute( "SELECT * FROM ".$this->_tablename." WHERE status='on' ORDER BY id DESC LIMIT ".($page*$pageitems).', '.$pageitems );
		$content = '';
		$templ = cmstemplates::loadfile( 'cmsguestbook_item', $this->_tablename );
		if( $rs ) {
			while( $record = $rs->FetchRow() ) {
				if( !$record['sender'] ) {
					$record['sender'] = CMSGUESTBOOK_ANONYMOUS;
				}
				$record['module'] = $this->_tablename;
				$record['content'] = SUCToXhtml( $record['content'] );
				$record['insert_time'] = date( DATE_FORMAT_SHORT, $record['insert_time'] );
				$content .= cmstemplates::parse( $templ, $record );
			}
			if( $page > 0 ) {
				$vars['pagedown'] = cmstemplates::show( 'cmsguestbook_pagedown', $this->_tablename, array( 'page' => $page-1 ) );
			} else {
				$vars['pagedown'] = '';
			}
			if( ( $page+1 ) < $totalpages ) {
				$vars['pageup'] = cmstemplates::show( 'cmsguestbook_pageup', $this->_tablename, array( 'page' => $page+1 ) );
			} else {
				$vars['pageup'] = '';
			}
			$vars['berichten'] = $content;
			$vars['message'] = $message;
			
			if( CMS_CURRENT_USER_ID ) 
			{
				$user = new cmsusers( $this->_db );
				$user->load( CMS_CURRENT_USER_ID );
				$vars['sender'] = $user->publicalias;
			} 
			else 
			{
				//$vars['sender'] = '';
			}
			//var_dump($vars);
			
			if(defined('CMS_GUESTBOOK_CAPTCHA') && CMS_GUESTBOOK_CAPTCHA)
        	{
        		$vars['captcha'] = cmstemplates::show('captchafield',null);
        	}	

			return cmstemplates::show( 'cmsguestbook', $this->_tablename, $vars );
		}
	}


}
?>